﻿var API =
{
	XML_URL : 'nStream.xml',
	channels : [ ],
	all_channels : [ ],
	chan_counter: 0,
	chan_pages : 0,
	last_page_channels_counter : 0,
	XHRObj : null,
	categories : [ ],
	timeFix : 0,
	timeFixSec : 0,
	yandex_days : 0,
}

API.init = function()
{
	try
	{
		var fileSystemObj = new FileSystem();
		var oFile=fileSystemObj.openCommonFile("nstreamplayer_url.dat", "r");
			
		if (oFile)
		{
			var url = oFile.readLine();
			if(url!="")
				this.XML_URL = url;
			var timefix = oFile.readLine();
			if (timefix)
				this.timeFix = parseInt(timefix);
			fileSystemObj.closeCommonFile(oFile);
		}
	}
	catch(e){
		ShowDebugOnScreen(e);
		alert('API.init ERROR');
	}
	var tm = new Date();
	this.timeFixSec = this.timeFix*60*60;
	API.todayDay();
	return true
}

API.todayDay = function()
{
	var minutes=1000*60;
	var hours=minutes*60;
	var days=hours*24;
	var t=Number(new Date());
	var days=t/days;
	this.yandex_days = parseInt(days+'');
}


API.Request = function()
{

	try
	{
		if (this.XHRObj != null) 
			this.XHRObj.destroy();

		this.XHRObj = new XMLHttpRequest();
		this.XHRObj.open("GET", this.XML_URL, false);

		this.XHRObj.send(null);
			
		if(this.XHRObj.readyState == 4)
			if(this.XHRObj.status == 200)
			{
				var xmlDoc = this.XHRObj.responseXML;
				return xmlDoc
			}
		
		Display.status("REQUEST ERROR");
		return false
		
	} catch(e){
		ShowDebugOnScreen('API.Request <br>' + e);
	}
}

API.getChannel_list = function()
{
	this.chan_counter = 0;

	try
	{
		var xmlChannels = API.Request();
		if(xmlChannels)
		{
			var items = xmlChannels.getElementsByTagName("channel");
			widgetAPI.putInnerHTML(document.getElementById("version"), 'nStreamPlayer 0.4Lmod');
			
			for (var index = 0; index < items.length; index++)
			{
				this.chan_counter = this.chan_counter + 1;
				
				var title = "";
				try
				{
				title = items[index].getElementsByTagName("title")[0].childNodes[0].nodeValue;
				} catch(e){
				alert('title not found');
				}
				
				var url = "";
				try
				{			
				url = items[index].getElementsByTagName("stream_url")[0].childNodes[0].nodeValue;
				} catch(e){
				alert('url not found');
				}
				
				var video_type = "";
				try
				{			
				video_type = items[index].getElementsByTagName("video_type")[0].childNodes[0].nodeValue;
				} catch(e){
				alert('video_type not found');
				}
				
				var logo_30x30 = "";			
				try
				{	
				logo_30x30 = items[index].getElementsByTagName("logo_30x30")[0].childNodes[0].nodeValue;
				} catch(e){
				alert('logo_30x30 not found');
				}
				
				var description = "";
				try
				{			
				description = items[index].getElementsByTagName("description")[0].childNodes[0].nodeValue;
				} catch(e){
				alert('description not found');
				}

				var category = "";
				try
				{			
				category = items[index].getElementsByTagName("category_id")[0].childNodes[0].nodeValue;
				} catch(e){
				alert('category not found');
				}

				var Channel = Array(this.chan_counter, title, url, video_type, logo_30x30, '', description, category);
				

				this.channels.push(Channel);
			}

			this.all_channels = this.channels;
			API.countPages();
			

			this.categories.push(Array('','ALL'));
			try
			{
				var category_items = xmlChannels.getElementsByTagName("category");
				
				
				alert('categories.length ' + category_items.length);
				for (var index = 0; index < category_items.length; index++)
				{		
					var cat_id = "";
					try
					{
						cat_id = category_items[index].getElementsByTagName("category_id")[0].childNodes[0].nodeValue;
					} catch(e){
						alert('category_id not found');
					}
					
					var cat_name = "";
					try
					{			
						cat_name = category_items[index].getElementsByTagName("category_title")[0].childNodes[0].nodeValue;
					} catch(e){
						alert('category_title not found');
					}	
					var Category = new Array(cat_id, cat_name);
					this.categories.push(Category);
					alert('hallo');
				}
				alert('categorie ' + this.categories);
			} catch(e){
				alert('category array not found');
			}
			if(this.chan_counter>0)
				return true
			else
			{
				Display.status("CHANNEL LIST ERROR");
				return false
			}		
		}
		else
		{
		document.getElementById("statusbar").style.display="block";
		widgetAPI.putInnerHTML(Display.statusDiv, '<b style="color:red">BAD URL or PLAYLIST ERROR</b>');
		}
	} catch(e){
		ShowDebugOnScreen('API.getChannel_list <br>' + e);
		alert('2: ' + e);
		return false
	}

}

API.setCategory = function(cat_id)
{
	this.channels = Array();
	if(cat_id=="")
		API.getChannel_list();
	else
	{	
		this.chan_counter = 0;
		Main.selected_channel = 0;
		Main.selected_page = 0;
		Main.chan_array_index = 0;
		for (var index = 0; index < this.all_channels.length; index++)
		{	
			if(this.all_channels[index][7]==cat_id)
				this.channels.push(this.all_channels[index]);
		}
		API.countPages();
	}
}

API.countPages = function()
{
	this.chan_counter = this.channels.length;

	this.chan_pages = this.chan_counter;
	this.last_page_channels_counter = this.chan_counter % 10;
	if(this.last_page_channels_counter==0)
		this.last_page_channels_counter = 10;
	
	if ( this.last_page_channels_counter > 0 && this.last_page_channels_counter < 5)
		this.chan_pages = Math.round(this.chan_pages / 10) + 1;
	else
		this.chan_pages = Math.round(this.chan_pages / 10);
}

API.IndexOfId = function(myarray, id)
{
	for (var index = 0; index < myarray.length; index++)
	{
		if(parseInt(myarray[index])==parseInt(id))
			return index
	}
	return -1
}

