﻿var widgetAPI = new Common.API.Widget();
var pluginAPI = new Common.API.Plugin();

var Main = {
	selected_channel: 0,
	selected_page: 0,
	chan_array_index: 0,
	MODE : -1,
    MainMenu_ID : 0,
    LivePlayer_ID : 1,
	StreamMode : "",
	player : null,
	serieC : false,
	PlayerMode: "",
	hardware : '',
	Selectbox_ID : 2,
	current_href_on_focus_id : 0,
	logo : true,
	yandextv_mode : false,
	scrolling : 0,
}

ConsoleLog = function (text) {

		var tm = new Date();
		var h = tm.getHours();
		var m = tm.getMinutes();
		var s = tm.getSeconds();
		var ms = tm.getMilliseconds();
		text = "[" + h + ":" + (m > 10 ? m : ("0" + m)) + ":" + (s > 10 ? s : ("0" + s)) + "," + ms + "] " + text;
		alert(text);
}

ShowDebugOnScreen = function(text)
{

		document.getElementById("statusbar").style.display="block";
		widgetAPI.putInnerHTML(document.getElementById("statusbar"), text);

}

Main.onLoad = function () 
{
	try
	{
		ConsoleLog('start');
		
		if(API.init() && Player.init() && Audio.init() && Display.init())
		{

				
			this.MODE = this.MainMenu_ID;	
			API.getChannel_list();
			alert('getChannel_list');

		}
		
		setInterval ("Main.UpdateTime();", 1000 );

		var networkPlugin = document.getElementById("pluginNetwork");
		
		var tvplug = document.getElementById("pluginTV");
		this.hardware = tvplug.GetProductCode(1);
		
		if(this.hardware.indexOf("C")>0)
			Main.serieC = true;
			
		setTimeout("Main.Starter();", 1000);
	}catch(e){
			ShowDebugOnScreen(e);
			alert('error: Main.onLoad ' + e);
			}
			
	if(API.chan_counter == 0)
	{
		Setup.setFormular();
	}
	KeyHandler.create();
	widgetAPI.sendReadyEvent();
	alert('API.chan_counter'  + API.chan_counter);
	
	setTimeout("Main.LogoStyle();", 1500);
	

}

Main.LogoStyle = function () 
{
	if(Main.logo)
	{
		document.getElementById("logo_bg").style.display="none";
		document.getElementById("leftHalf").style.display="block";
		document.getElementById("rightHalf").style.display="block";
		Main.logo = false;
	}
}

Main.Starter  = function()
{

		Main.Menu();

}

Main.Menu = function()
{
	
	document.getElementById("help_navi_menu").style.display="block";
	document.getElementById("channelList").style.display="";

	try
	{	
		Main.updatePage();
		Main.updateChannel();
/*
		if(Player.state == Player.PLAYING_LIVE)
			document.getElementById("back_to_player").style.display="block";
		else
			document.getElementById("back_to_player").style.display="none";
*/
		KeyHandler.setFocus(this.MainMenu_ID);
	} catch(e){
		alert("Main.Menu ERROR: "+e);
	}	
}

Main.showCategorySelector = function()
{
	KeyHandler.setFocus(Main.Selectbox_ID);
	alert('API.categories ' + API.categories);
	Selectbox.setBox('CATEGORIES', API.categories);
}

Main.updatePage = function()
{	

	try
	{
		var chan = Array();
		var time = 0;
		var chan_on_page = 10;

		if(this.selected_page > API.chan_pages-1)
			this.selected_page = 0;
			
		if(this.selected_page < 0)
			this.selected_page = API.chan_pages-1;
		
		for (var index = 0; index < 10; index++)
			{
				document.getElementById("ch"+index).style.display="";
				widgetAPI.putInnerHTML(document.getElementById("title"+index), "");
				widgetAPI.putInnerHTML(document.getElementById("descr"+index), "");
				document.getElementById("descr"+index).style.display="";
				document.getElementById("title"+index).style.width= "200px";
				document.getElementById("number"+index).style = "";
			}
		
		if(this.selected_page == API.chan_pages-1)
		{
			chan_on_page = API.last_page_channels_counter;
			
				for (var index = chan_on_page; index < 10; index++)
				{
					document.getElementById("ch"+index).style.display="none";
				}
				
			if(this.selected_channel > API.last_page_channels_counter-1)
				this.selected_channel = API.last_page_channels_counter-1;
		}

		for (var index = 0; index < chan_on_page; index++)
		{
			var chan_array_index = 10*this.selected_page + index;
			
			chan[index] = document.getElementById("chan"+index);
			//chan[index].style.backgroundImage= "url(img/menu.png)";

			
			widgetAPI.putInnerHTML(document.getElementById("number"+index), chan_array_index+1);
			var logo = API.channels[chan_array_index][4];
			var logopapka = "logos/"
			if(logo.indexOf(":")>0)
               logopapka = "";
			if(logo!="")
				document.getElementById("img"+index).src=logopapka+logo;
			else
				document.getElementById("img"+index).src="img/dummy.png";
			
			widgetAPI.putInnerHTML(document.getElementById("title"+index), API.channels[chan_array_index][1]);
			if(API.channels[chan_array_index][8])
			{
				var text = '(info)&nbsp;' + API.channels[chan_array_index][8];
				widgetAPI.putInnerHTML(document.getElementById("descr"+index), text);			
			}

		}
	
	} catch(e){
		alert("API.updatePage ERROR: "+e);
		document.getElementById("statusbar").style.display="block";
		widgetAPI.putInnerHTML(Display.statusDiv, '4: ' + e);
	}

}

Main.updateChannel = function()
{
	if(API.chan_counter>0)
	{
		for (var index = 0; index < 10; index++)
		{
			document.getElementById("chan"+index).style.backgroundImage= "";
			document.getElementById("number"+index).style.backgroundImage = "";
		}
		
		this.chan_array_index = 10*this.selected_page + this.selected_channel;

		document.getElementById("number"+this.selected_channel).style.backgroundImage= "url(img/menu1_act.png)";
		document.getElementById("chan"+this.selected_channel).style.backgroundImage= "url(img/menu_act.png)";
		
		document.getElementById("yandex").style.display="none";
		this.yandextv_mode = false;
		if(API.channels[this.chan_array_index][6].indexOf('/m.tv.yandex.ru/')!= -1)
			Main.yandexTVinfo();
		else
			widgetAPI.putInnerHTML(document.getElementById("infoList"), API.channels[this.chan_array_index][6]);
			
		Main.UpdatePlayerStatusbar();
	}

}

Main.yandexTVinfo = function()
{
	this.yandextv_mode = true;
	var description = API.channels[this.chan_array_index][6].replace("#######",API.yandex_days);
	alert('NEW description: ' + description);
	document.getElementById("yandex").style.display="block";
	widgetAPI.putInnerHTML(document.getElementById("infoList"), description);		
	if(this.yandextv_mode)
		setTimeout("Main.yandexTVdisableSelector();",1000);
}

Main.yandexTVdisableSelector = function()
{	
	var b_schedule = document.frames['yandex_tv'].document.getElementsByClassName("b-schedule")[0].innerHTML;
	widgetAPI.putInnerHTML(document.getElementById("infoList"), b_schedule);
}

Main.DisableGone = function()
{
		if(document.getElementsByClassName("gone"))
		{
		className = 'done';
		//document.frames['yandex_tv'].styles.className.display = 'none';
		var test = document.getElementById("infoList");		
		var gone = document.getElementsByClassName("gone");

		  for(i=0;i<gone.length;i++)
			gone[i].style.display = 'none';	
		}
		
		alert(' test ' + test.innerHTML)
}



Main.selectNextChannel = function()
{

	this.selected_channel++;
	if(this.selected_channel>=10 || (this.selected_page == API.chan_pages-1 && this.selected_channel==API.last_page_channels_counter))
	{
		this.selected_channel = 0;
		this.selected_page++;
		Main.updatePage();
	}

	Main.updateChannel();
}

Main.selectPrevChannel = function()
{

	this.selected_channel--;
	
	if(this.selected_page == 0 && this.selected_channel<0)
	{
		this.selected_channel = API.last_page_channels_counter - 1;
		this.selected_page = API.chan_pages-1;
		Main.updatePage();
	}
	
	if(this.selected_channel<0)
	{
		this.selected_channel = 9;
		this.selected_page--;
		Main.updatePage();
		
	}
	
	Main.updateChannel();
}

Main.selectNextPage = function()
{
	this.selected_page++;
	Main.updatePage();
	Main.updateChannel();
}

Main.selectPrevPage = function()
{

	this.selected_page--;
	Main.updatePage();
	Main.updateChannel();
}

Main.PlayChannel = function()
{	
	try
	{	
		KeyHandler.setFocus(this.LivePlayer_ID);
		Player.selected_channel = this.selected_channel;
		Player.selected_page = this.selected_page;
		Player.chan_array_index = this.chan_array_index;
		
		if(API.channels[this.chan_array_index][3]=="flash_rtmp")
		{
			Main.PlayerMode = "0";
			Main.StreamMode = "rtmp";
			Main.PlayFlashStream();
		}
		if(API.channels[this.chan_array_index][3]=="flash_flv")
		{
			Main.PlayerMode = "0";
			Main.StreamMode = "flv";
			Main.PlayFlashStream();
		}
		if(API.channels[this.chan_array_index][3]=="hls")
		{
			Main.PlayerMode = "1";
			Main.StreamMode = "hls";
			Main.PlayNoFlashStream();
		}
		if(API.channels[this.chan_array_index][3]=="http")
		{
			Main.PlayerMode = "1";
			Main.StreamMode = "http";
			Main.PlayNoFlashStream();
		}
	}
	catch(e){
			ShowDebugOnScreen('Main.PlayChannel <br>' + e);
			}
}	

Main.PlayNoFlashStream = function()
{	
	
	
	delete Main.player;
				document.getElementById("flashplayer").style.display="none";
				document.getElementById("main").style.display="block";
				widgetAPI.putInnerHTML(document.getElementById("flashplayer"), "");
                                                                     	
	document.getElementById("screen_size").style.display="block";		
	widgetAPI.putInnerHTML(document.getElementById("resolution"), '');
	Player.selected_channel = this.selected_channel;
	Player.selected_page = this.selected_page;
	Player.chan_array_index = this.chan_array_index;
	Display.hidemenu();

	var url = API.channels[this.chan_array_index][2];
	if(Main.StreamMode == "hls")
		url = url + "|COMPONENT=HLS";
	Player.setVideoURL(url);
	
									
	Player.playVideo();
	Display.showplayer();
}
	
Main.PlayFlashStream = function()
{
	document.getElementById("screen_size").style.display="none";
	Player.stopVideo();
	Player.state = Player.STOPPED;
	if(!Main.serieC)
		Player.state = Player.PLAYING_LIVE;
	
	widgetAPI.putInnerHTML(document.getElementById("resolution"), '');
	
	document.getElementById("main").style.display="none";
	document.getElementById("flashplayer").style.display="block";
	widgetAPI.putInnerHTML(document.getElementById("flashplayer"), "");
	
	var flash_stream_url = API.channels[this.chan_array_index][2];
	var params = "";
	if(Main.StreamMode == "rtmp")
		params = "file=" + flash_stream_url;

	if(Main.StreamMode == "flv")
		params =  "flv=" + flash_stream_url;

		
	var p;
	p='<object type="application/x-shockwave-flash" id="rmtpplayerHD" width="960" height="540">';
	p=p+'<param name="movie" value="nflashplayer.swf" />';
	p=p+'<param name="FlashVars" value="' + params + '" /></object>'; 
	alert ("p: " + p );
	
	widgetAPI.putInnerHTML(document.getElementById("flashplayer"), p);
	setTimeout("Main.setPlayer();",300);
}	

Main.setPlayer = function()
{
	delete Main.player;
	Main.player = window["rmtpplayerHD"];
}

Main.UpdatePlayerStatusbar = function()
{
	var index = this.chan_array_index;
	this.browser_url = API.channels[index][8];

	widgetAPI.putInnerHTML(document.getElementById("ch_number"),index+1);
	widgetAPI.putInnerHTML(document.getElementById("ch_name"),API.channels[index][1]);
	widgetAPI.putInnerHTML(document.getElementById("ch_category"),'');
	widgetAPI.putInnerHTML(document.getElementById("time"),"");
	
	var logo = API.channels[index][4];
	var logopapka = "logos/"
	if(logo.indexOf(":")>0)
	   logopapka = "";
	if(logo!="")
		document.getElementById("ch_img").src=logopapka+logo;
	else
		document.getElementById("ch_img").src="img/dummy.png";
		
	

	widgetAPI.putInnerHTML(document.getElementById("pr1_name"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr1_descr"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr2_name"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr2_descr"),"");


}

Main.UpdateTime = function()
{ 
   var fix = Number(new Date()) + API.timeFixSec*1000;
   var now = new Date(fix);//FIX
   var hours = now.getHours();                                        
   var minutes = now.getMinutes();                                    
   var seconds = now.getSeconds();                                    
   var timeValue = ((hours < 10) ? "0" : "") + + hours;               
   timeValue  += ((minutes < 10) ? ":0" : ":") + minutes;             
   timeValue  += ((seconds < 10) ? ":0" : ":") + seconds;   
   document.getElementById('widget_time').innerHTML=timeValue; 
   document.getElementById('time').innerHTML=timeValue; 
   Main.DateMenu();
   

}

Main.onUnload = function()
{
	Audio.setVolume(10);
	alert("DEINIT");
	Player.deinit();
}

Main.DateMenu = function()
{
   var fix = Number(new Date()) + API.timeFixSec*1000;
   var Unixtime = new Date(fix);//FIX
	var days= new Array ("Воскресенье", "Понедельник", "Вторник", "Среда", "Четверг","Пятница", "Суббота");
	var monts = new Array ("Января", "Февраля","Марта", "Апреля", "Мая", "Июня","Июля", "Августа","Сентября", "Октября","Ноября","Декабря");
	var WeekDay = days[Unixtime.getDay()];
	var Day = Unixtime.getDate();
	var Month = monts[Unixtime.getMonth()];
	var dateValue = WeekDay +" "+ Day +" "+ Month;
	document.getElementById('widget_date').innerHTML=dateValue; 
}



