﻿var Player =
{
    selected_channel: 0,
	selected_page: 0,
	chan_array_index: 0,
	plugin : null,
	mwPlugin: null,
              state : -1,
              size: 0,
        w: 0,
        h: 0,
    STOPPED : 0,
    PLAYING_LIVE : 1,
	originalSource : null,
}

Player.init = function()
{
    var success = true;
    
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");
    
    if (!this.plugin)
    {
         success = false;
    }

	this.mwPlugin = document.getElementById("pluginObjectTVMW");
	if (!this.mwPlugin || !this.mwPlugin.GetSource) 
	{
		success = false;
	} 
	else 
	{
		this.originalSource = this.mwPlugin.GetSource();
		this.mwPlugin.SetMediaSource();
	}

		
	this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
	this.plugin.OnCurrentPlayTime = 'Player.CurrentTime';
	this.plugin.OnStreamInfoReady = 'Player.OnStreamInfoReady';
	
	this.plugin.OnConnectionFailed = 'Player.OnConnectionFailed';
	this.plugin.OnNetworkDisconnected = 'Player.OnNetworkDisconnected';
	this.plugin.OnStreamNotFound = 'Player.OnStreamNotFound';
	this.plugin.OnRenderError = 'Player.OnRenderError';
	this.plugin.onServerError = 'Player.onServerError';
		
    return success;
}


// Global functions called directly by the player 
Player.OnConnectionFailed = function()
{
    Display.status("Connection Failed!");
	Player.matrixReload();
	ConsoleLog('OnConnectionFailed');
}

Player.OnNetworkDisconnected = function()
{
	Display.status("Network Disconnected!");
	Player.playVideo();
}

Player.OnStreamNotFound = function()
{
	Display.status("Stream Not Found!");
	Player.playVideo();
}

Player.OnStreamInfoReady = function()
{
	Player.setSize(Player.size, 0);
	Player.ShowResolution();
}
		
Player.OnRenderError = function()
{
    Display.status("Render Error!");
	Player.playVideo();
}

Player.onServerError = function()
{
    Player.matrixReload();
	Display.status("Server Error!");
	Player.playVideo();
}

getBandwidth = function(bandwidth) { ConsoleLog("getBandwidth " + bandwidth); }

onDecoderReady = function() { ConsoleLogt("onDecoderReady"); }

onRenderError = function() { ConsoleLog("onRenderError"); }

Player.onBufferingStart = function()
{
    Display.status("Buffering...");
	ConsoleLog("Buffering...");
}

Player.onBufferingProgress = function(percent)
{
    Display.status("Buffering:" + percent + "%");
	ConsoleLog("Buffering:" + percent + "%");
}

Player.onBufferingComplete = function()
{
	Display.status("Buffering Complete");
	ConsoleLog("Buffering Complete");
}

Player.CurrentTime = function(time)
{
}

Player.deinit = function()
{
	if (this.plugin)
	{
		this.plugin.Stop();
	}
	ConsoleLog("Player deinit !!! " ); 
	if(this.mwPlugin != null)
		this.mwPlugin.SetMediaSource(this.originalSource);
	

}

Player.setVideoURL = function(url)
{
    this.url = url;
    ConsoleLog("URL = " + this.url);
}

Player.playVideo = function()
{	
		
	if (this.url == null)
    {
        ConsoleLog("No videos to play");
    }
    else
    {
		this.plugin.Stop();
		pluginAPI.setOffScreenSaver();
                            this.plugin.Play( this.url );
                            Audio.plugin.SetSystemMute(false); 
		Player.state = Player.PLAYING_LIVE;
    }
	ConsoleLog("Play");
		

}


Player.getState = function()
{
    return this.state;
}

stopPlayer = function()
{
    Player.stopVideo();
}

Player.stopVideo = function()
{

	Display.status("Stop");
	if (this.state != this.STOPPED)
    {
        this.state = this.STOPPED;
        Display.status("Stop");
        this.plugin.Stop();
        
    }
    else
    {
        alert("Ignoring stop request, not in correct state");
    }
}

Player.ShowResolution = function()
{
	var h=this.plugin.GetVideoHeight();
	var w=this.plugin.GetVideoWidth();
	var res = "<center>" + w + "X" + h + "</center>";
	widgetAPI.putInnerHTML(document.getElementById("resolution"), res);
			
}		

Player.setTottalBuffer = function(buffer) 
{ 
	var new_buffer = this.plugin.setTotalBufferSize(buffer);
	ConsoleLog("setTottalBuffer " + new_buffer); 
	Display.status(new_buffer);

}

Player.setInitialBuffer = function(buffer) 
{ 
	
	var new_buffer = this.plugin.setInitialBuffer(buffer);
	ConsoleLog("setInitialBuffer " + new_buffer); 


}

Player.setSize=function(mode, show)
    {
        alert('Player.setSize this.state ' + this.state);
		if (this.state != this.STOPPED)
        {
            this.size=mode;

            var h=this.plugin.GetVideoHeight();
            var w=this.plugin.GetVideoWidth();
            var l;
            var t;
            switch(mode)
			{
			case 0 :

					if(show>0)
						Display.status('16x9 FULL');
                                                          this.plugin.SetCropArea(0, 0, w,h);
                                                         this.plugin.SetDisplayArea(0, 0, 960, 540);
                                                         
                                                      break;

                                        case 1 :
                        
                                                           l=0.0625*w;
                                                           t=0.0625*h;
                                                           w=0.875*w;
                                                           h=0.875*h;
                                                 if(show>0)
                                                            Display.status('16x9 ZOOM');
                                                            this.plugin.SetDisplayArea(0, 0, 960, 540);
                                                            this.plugin.SetCropArea(l, t, w,h);
                                                      break;
			case 2 :
                                                          l=0;
                                                          t=0.0625*h;
                                                          h=0.875*h;
                                                  if(show>0)
                                                                 Display.status('14x9 ZOOM');
                                                                   this.plugin.SetDisplayArea(0, 0, 960, 540);
                                                                   this.plugin.SetCropArea(l, t, w,h);
                                                      break;					
			case 3 :
					if(w<960)
					{
					var z = 960/w;//0,75
					var m = parseInt(z*h);
					var y = parseInt((540-m)/2);
					if(w/h>1.777)
					{
						if(show>0)
							Display.status('16x9 ORIGINAL');
						this.plugin.SetDisplayArea(0, y, 960, m);
					}
					else
					{
						if(show>0)
							Display.status('4x3 KINOZOOM');
						this.plugin.SetCropArea(0, 70, w, 436);
						this.plugin.SetDisplayArea(0, 0, 960, 540);
                                                                      }
                                                                      }
					else
						Display.status('не поддерживается');
					break;			
			 case 4 :
					//[4x3]
					if(w<=720)
					{
						if(show>0)
							Display.status('4x3');
						this.plugin.SetCropArea(0, 0, w, h);
						this.plugin.SetDisplayArea(120,0,720,540);
					}
					else
						Display.status('не поддерживается');
					break;		   

			}
                 }
    }


Player.getSize=function() {return this.size;}